/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the DeleteSegmentGroupRequestInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &DeleteSegmentGroupRequestInner{}

// DeleteSegmentGroupRequestInner struct for DeleteSegmentGroupRequestInner
type DeleteSegmentGroupRequestInner struct {
	Key string `json:"key"`
	SelectedIds []string `json:"selected_ids,omitempty"`
	SelectionMode string `json:"selection_mode"`
}

// NewDeleteSegmentGroupRequestInner instantiates a new DeleteSegmentGroupRequestInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewDeleteSegmentGroupRequestInner(key string, selectionMode string) *DeleteSegmentGroupRequestInner {
	this := DeleteSegmentGroupRequestInner{}
	this.Key = key
	this.SelectionMode = selectionMode
	return &this
}

// NewDeleteSegmentGroupRequestInnerWithDefaults instantiates a new DeleteSegmentGroupRequestInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewDeleteSegmentGroupRequestInnerWithDefaults() *DeleteSegmentGroupRequestInner {
	this := DeleteSegmentGroupRequestInner{}
	return &this
}

// GetKey returns the Key field value
func (o *DeleteSegmentGroupRequestInner) GetKey() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Key
}

// GetKeyOk returns a tuple with the Key field value
// and a boolean to check if the value has been set.
func (o *DeleteSegmentGroupRequestInner) GetKeyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Key, true
}

// SetKey sets field value
func (o *DeleteSegmentGroupRequestInner) SetKey(v string) {
	o.Key = v
}

// GetSelectedIds returns the SelectedIds field value if set, zero value otherwise.
func (o *DeleteSegmentGroupRequestInner) GetSelectedIds() []string {
	if o == nil || IsNil(o.SelectedIds) {
		var ret []string
		return ret
	}
	return o.SelectedIds
}

// GetSelectedIdsOk returns a tuple with the SelectedIds field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DeleteSegmentGroupRequestInner) GetSelectedIdsOk() ([]string, bool) {
	if o == nil || IsNil(o.SelectedIds) {
		return nil, false
	}
	return o.SelectedIds, true
}

// HasSelectedIds returns a boolean if a field has been set.
func (o *DeleteSegmentGroupRequestInner) HasSelectedIds() bool {
	if o != nil && !IsNil(o.SelectedIds) {
		return true
	}

	return false
}

// SetSelectedIds gets a reference to the given []string and assigns it to the SelectedIds field.
func (o *DeleteSegmentGroupRequestInner) SetSelectedIds(v []string) {
	o.SelectedIds = v
}

// GetSelectionMode returns the SelectionMode field value
func (o *DeleteSegmentGroupRequestInner) GetSelectionMode() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.SelectionMode
}

// GetSelectionModeOk returns a tuple with the SelectionMode field value
// and a boolean to check if the value has been set.
func (o *DeleteSegmentGroupRequestInner) GetSelectionModeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.SelectionMode, true
}

// SetSelectionMode sets field value
func (o *DeleteSegmentGroupRequestInner) SetSelectionMode(v string) {
	o.SelectionMode = v
}

func (o DeleteSegmentGroupRequestInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o DeleteSegmentGroupRequestInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["key"] = o.Key
	if !IsNil(o.SelectedIds) {
		toSerialize["selected_ids"] = o.SelectedIds
	}
	toSerialize["selection_mode"] = o.SelectionMode
	return toSerialize, nil
}

type NullableDeleteSegmentGroupRequestInner struct {
	value *DeleteSegmentGroupRequestInner
	isSet bool
}

func (v NullableDeleteSegmentGroupRequestInner) Get() *DeleteSegmentGroupRequestInner {
	return v.value
}

func (v *NullableDeleteSegmentGroupRequestInner) Set(val *DeleteSegmentGroupRequestInner) {
	v.value = val
	v.isSet = true
}

func (v NullableDeleteSegmentGroupRequestInner) IsSet() bool {
	return v.isSet
}

func (v *NullableDeleteSegmentGroupRequestInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableDeleteSegmentGroupRequestInner(val *DeleteSegmentGroupRequestInner) *NullableDeleteSegmentGroupRequestInner {
	return &NullableDeleteSegmentGroupRequestInner{value: val, isSet: true}
}

func (v NullableDeleteSegmentGroupRequestInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableDeleteSegmentGroupRequestInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


